models/Editoriales.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "editoriales".
 *
 * @property int $id_editorial
 * @property string $editorial
 *
 * @property Libros[] $libros
 */
class Editoriales extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'editoriales';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['editorial'], 'required'],
            [['editorial'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id_editorial' => 'Id Editorial',
            'editorial' => 'Editorial',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getLibros()
    {
        return $this->hasMany(Libros::className(), ['id_editorial' => 'id_editorial']);
    }
}

controllers/EditorialesController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Editoriales;
use app\models\EditorialesSearch;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EditorialesController implements the CRUD actions for Editoriales model.
 */
class EditorialesController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Editoriales models.
     * @return mixed
     */
    public function actionIndex()
    {
       $searchModel = new EditorialesSearch();
       $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
       
       return $this->render('index', [
           'searchModel' => $searchModel, 
           'dataProvider' => $dataProvider,
       ]);
           
    }
    
    public function buscarLibros($id){
        return null;
    }

    /**
     * Displays a single Editoriales model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Editoriales model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Editoriales();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_editorial]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Editoriales model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_editorial]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Editoriales model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Editoriales model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Editoriales the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Editoriales::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/LibrosController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Libros;
use app\models\LibrosSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LibrosController implements the CRUD actions for Libros model.
 */
class LibrosController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Libros models.
     * @return mixed
     */
    public function actionIndex(){
        $consulta= Yii::$app->db->createCommand("SELECT DISTINCT libros.*,editorial FROM libros JOIN escriben USING (id_libro)
        JOIN autores USING (id_autor)
        JOIN editoriales USING (id_editorial);")
                ->queryAll();
        return $this->render('index',['datos'=>$consulta]);

    }
    
   
    
    
    public function actionBuscar()
    {
        $searchModel = new LibrosSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Libros model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        $model=$this->findModel($id);
        $leido=($model->leido==0)?"No":"Si";
        $coleccion=($model->id_coleccion==null)?"No tiene Colección":$model->id_coleccion;
        $autores= Yii::$app->db->createCommand("SELECT autor from autores JOIN escriben USING(id_autor) WHERE id_libro=$model->id_libro")->queryAll();
        $autor="";
        foreach($autores as $valor){
            $autor.= $valor["autor"]."  ";
        }
        $editorial= (new \yii\db\Query())
                ->select('editorial')
                ->from('editoriales')
                ->join('INNER JOIN', 'libros', 'editoriales.id_editorial=libros.id_editorial')
                ->where("id_libro=$id")
                ->one();
        
        return $this->render('view', [
            'model' =>$model,
            'leido'=>$leido,
            'coleccion'=>$coleccion,
            'autor'=>$autor,
            'editorial'=>$editorial["editorial"],
        ]);
    }

    /**
     * Creates a new Libros model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Libros();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_libro]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Libros model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_libro]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Libros model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Libros model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Libros the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Libros::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/editoriales/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Editoriales */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="editoriales-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'editorial')->textInput(['maxlength' => true]) ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/editoriales/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\EditorialesSearch */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="editoriales-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'id_editorial') ?>

    <?= $form->field($model, 'editorial') ?>

    <div class="form-group">
        <?= Html::submitButton('Search', ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton('Reset', ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/editoriales/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\Editoriales */

$this->title = 'Create Editoriales';
$this->params['breadcrumbs'][] = ['label' => 'Editoriales', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="editoriales-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/editoriales/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\models\Editoriales;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Editoriales';
$this->params['breadcrumbs'][] = $this->title;

$model=$dataProvider->models;

?>
<div class="editoriales-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Crear Editorial', ['create'], ['class' => 'btn btn-success']) ?>
        <?php  //echo $this->render('_search', ['model' => $searchModel]); ?> 
    </p>
   
    
    <?=    Gridview::widget([
        'dataProvider' => $dataProvider,
      
        'summary'=>'Mostrando {begin} - {end} de {totalCount} editoriales',
        'filterModel' => $searchModel,
        'columns' => [
           //['class' => 'yii\grid\SerialColumn'],    
            'id_editorial',
            'editorial',
            [
               'label'=>'Libros de la Editorial',
                'format'=>'raw',
                'value'=> function($model){
                    $libros=$model->getLibros()->all();
                    $url="";
                    foreach($libros as $reg){
                        $url.=Html::a($reg->titulo,["libros/view","id"=>$reg->id_libro])."<br>";
                    }
                    return  $url;
               }
            ],
        ]
    ]); ?>
</div>

views/editoriales/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Editoriales */

$this->title = 'Update Editoriales: ' . $model->id_editorial;
$this->params['breadcrumbs'][] = ['label' => 'Editoriales', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id_editorial, 'url' => ['view', 'id' => $model->id_editorial]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="editoriales-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/editoriales/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Editoriales */

$this->title = $model->id_editorial;
$this->params['breadcrumbs'][] = ['label' => 'Editoriales', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="editoriales-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id_editorial], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id_editorial], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id_editorial',
            'editorial',
        ],
    ]) ?>

</div>